<template>
  <div class="LaboratoryResearch">
    <div v-if="!load && !isSearch" class="wrap q-pa-md q-gutter-sm">
      <div class="flex items-center">
        <router-link v-if="isSearch === false && !searchArr.length" :to="{name: (pathName[1].params.id && pathName[1].path || 'Index'), params: {id: (pathName[1].params.id || '0')}}">
          <q-btn flat icon="arrow_left" label="Назад" />
        </router-link>
        <div v-else>
          <q-btn @click="setIsSearch" flat icon="arrow_left" label="Назад" />
        </div>
        <Breadcrumbs :path="pathName"/>
      </div>
      <div v-for="(category, index) in ResearchOption" :key="category.id_clr">
        <div class="expand p-2" @click.prevent="edit(index)">
          <div class="flex items-center">
            <p class="count mr-4">{{index + 1}}</p>
            <img src="../assets/images/icons/research_options.png" width="16" class="mr-4" alt="">
            <div class="flex flex-wrap max-w-[80%]">
              <p class="mr-3 truncate">{{LaboratoryResearch.name_lr}}, {{category.id_ro}} {{category.DescriptionRO}}</p>
            </div>
            <img @click.prevent="edit(index)"
                 src="../assets/images/icons/pencil-outline.svg"
                 width="16"
                 class="ml-auto mr-4"
                 alt=""
            >
          </div>
        </div>
      </div>
      <div>
        <q-btn @click="fullModal = true" flat label="Добавить иследование" color="green" style="position: absolute; bottom: 50px"/>
      </div>
    </div>
    <div v-else-if="isSearch">
      <router-link to="/" @click.prevent="clearSearch">
        <q-btn flat icon="arrow_left" label="Назад" />
      </router-link>
      <div class="text-center my-6 text-xl opacity-70">Найдено исследований: <span class="text-white px-4 py-1 bg-black rounded-md text-ls">{{searchArr.length}}</span></div>
      <div v-for="(category, index) in searchArr" :key="category.id_clr">
        <div v-if="category" class="expand p-2">
          <router-link
            :to="{name: 'ResearchOption', params: {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr}}"
            @click="save(category, category.name_lr, 'ResearchOption', {id: category.id_clr, id_clr: category.id_clr, id_lr: category.id_lr})"
            class="flex"
          >
            <p class="count mr-4">{{index + 1}}</p>
            <img src="../assets/images/icons/lab.png" width="16" class="mr-4" alt="">
            <p class="name_clr truncate" :title="category.name_lr">{{category.name_lr}}</p>
            <img
              src="../assets/images/icons/pencil-outline.svg"
              width="16"
              class="ml-auto mr-4"
              alt=""
              v-if="1===2"
            >
          </router-link>
        </div>
      </div>
    </div>
    <div v-else class="flex justify-center mt-16">
      <LoadsSpinner v-if="load" large/>
    </div>
    <Modal v-if="modalEdit" @close="modalEdit = false" background-color="white" class="text-white">
      <template #body>
        <div class="min-w-lg">
          <div class="text-lg opacity-70 mb-4 text-black">Редактирование</div>
          <q-input autofocus v-model="editResearchOption.name_lr" label="Название"/>
          <q-input v-model="editResearchOption.Fullname_lr" label="Полное название"/>
          <q-input v-model="editResearchOption.DescriptionLR" label="Описание"/>
          <div class="edit-modal-switch-wrap">
            <q-toggle v-model="editResearchOption.ForMensPossible" :label="editResearchOption.ForMensPossible && 'Подходит для мужчин' || 'Не подходит для мужчин'"/>
            <q-toggle v-model="editResearchOption.ForWomensPossible" :label="editResearchOption.ForWomensPossible && 'Подходит для женщин' || 'Не подходит для женщин'"/>
            <q-toggle v-model="editResearchOption.NA" :label="editResearchOption.NA && 'Исследование активно' || 'Исследование не активно'"/>
          </div>
          <div class="flex mt-4 justify-end">
            <q-btn color="red" label="Удалить" class="mr-2" />
            <q-btn color="primary" label="Применить" />
          </div>
        </div>
      </template>
    </Modal>
    <FullModal v-if="modalEdit" @close="modalEdit = false" is-close>
      <template #body>
        <p class="text-white opacity-70 text-xl mb-6">Редактирование иследование</p>
        <div class="xl:px-24 sm:px-0 pt-2">
          <div class="modal-add-laboratory">
            <div class="head">
              <div class="text-left px-10">
                <div v-if="Category.name_clr">1. {{`${Index.name_clr} > ${Category.name_clr}`}}</div>
                <div v-else>1. {{`${Index.name_clr}`}}</div>
                <div>2. {{LaboratoryResearch.name_lr}}</div>
                <div>3. {{LaboratoryResearch.full_name_lr}}</div>
                <div>4. {{LaboratoryResearch.desc_lr}}</div>
              </div>
            </div>

            <div class="materials mt-10">
              <div>
                <p class="mx-auto opacity-70 text-lg">Био материалы</p>
                <div class="text-start text-white" v-for="elem in InvestigatedBiologicalMaterial">
                  <div v-if="elem.research_options">
                    <div v-for="el in elem.research_options">
                      <div v-for="el1 in el.bm_of_study">
                        <input v-if="el1.bio_materials" v-model="el1.bio_materials.name_bm" type="text">
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div>
                <p class="mx-auto opacity-70 text-lg">Расходные материалы</p>
                <div class="text-left" v-for="elem in ExpendableMaterials">
                  <div v-if="elem.research_options">
                    {{el}}
                    <div v-for="el in elem.research_options">
                      <div v-for="el1 in el.use_m">
                        <input v-model="el1.materials.name_m" type="text">
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="table mt-10">
              <div class="table-wrap" style="flex-direction: column">
                <table style="padding-left: 50px">
                  <tbody>
                  <tr>
                    <th
                      v-for="row in head"
                      :key="`table-${row.id}-th`"
                      v-show="row.name !== 'Полное название'"
                    >
                      <div class="d-flex justify-center align-center flex-column search-head">
                        {{row.name}}
                      </div>
                    </th>
                  </tr>
                  <tr
                    v-for="(col, index) in columns"
                    :key="col.code_l + index"
                  >
                    <td>{{col.laboratories.name_lab}}</td>
                    <td>{{col.desc_lo}}</td>
                    <td>{{col.code_l}}</td>
                    <td>{{col.old_code_l}}</td>
                    <td>{{col.cost_lo}}</td>
                    <td>{{col.lead_time}}</td>
                    <td><q-icon :name="col.fast_execution && 'font_check' || 'close'" /></td>
                    <td>{{col.fast_exec_cost}}</td>
                    <td>{{col.fast_exec_time}}</td>
                  </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
          <div class="mt-16 flex justify-end">
            <q-btn label="Отмена" color="red" class="mr-2" @click.native="modalEdit = false"/>
            <q-btn label="Сохранить" color="primary" @click.native="modalEdit = false"/>
          </div>
        </div>
      </template>
    </FullModal>
    <FullModal v-if="fullModal" @close="fullModal = false" is-close>
      <template #body>
        <p class="text-white opacity-70 text-xl mb-6">Новое иследование</p>
        <div class="xl:px-24 sm:px-0 pt-2">
          <div class="modal-add-laboratory">
            <div class="head">
              <div class="text-left px-10">
                <div v-if="Category.name_clr">1. {{`${Index.name_clr} > ${Category.name_clr}`}}</div>
                <div v-else>1. {{`${Index.name_clr}`}}</div>
                <div>2. {{LaboratoryResearch.name_lr}}</div>
                <div>3. {{LaboratoryResearch.full_name_lr}}</div>
                <div>4. {{LaboratoryResearch.desc_lr}}</div>
              </div>
              <div class="flex column justify-start">
                <q-toggle
                  v-model="LaboratoryResearch.for_mens"
                  :label="LaboratoryResearch.for_mens && 'Подходит для мужчин' || 'Не подходит для мужчин'"/>
                <q-toggle
                  v-model="LaboratoryResearch.for_womens"
                  :label="LaboratoryResearch.for_womens && 'Подходит для женщин' || 'Не подходит для женщин'"/>
              </div>
            </div>

            <div class="materials mt-10">
              <div>
                <p class="mx-auto opacity-70 text-lg">Био материалы</p>
                <div class="text-start text-white" v-for="elem in InvestigatedBiologicalMaterial">
                  <div v-if="elem.research_options">
                    <div v-for="el in elem.research_options">
                      <div v-for="el1 in el.bm_of_study">
                        <input v-if="el1.bio_materials" v-model="el1.bio_materials.name_bm" type="text">
                      </div>
                    </div>
                  </div>
                </div>
              </div>
              <div>
                <p class="mx-auto opacity-70 text-lg">Расходные материалы</p>
                <div class="text-left" v-for="elem in ExpendableMaterials">
                  <div v-if="elem.research_options">
                    {{el}}
                    <div v-for="el in elem.research_options">
                      <div v-for="el1 in el.use_m">
                        <input v-model="el1.materials.name_m" type="text">
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="table mt-10">
              <div class="table-wrap" style="flex-direction: column">
                <table style="padding-left: 50px">
                  <tbody>
                    <tr>
                      <th
                        v-for="row in head"
                        :key="`table-${row.id}-th`"
                        v-show="row"
                      >
                        <div class="d-flex justify-center align-center flex-column search-head">
                          {{row.name}}
                        </div>
                      </th>
                    </tr>
                    <tr
                      v-for="(col, index) in columns"
                      :key="col.code_l + index"
                    >
                      <td>{{col.laboratories.name_lab}}</td>
                      <td>{{col.laboratories.FullNameLabs}}</td>
                      <td>{{col.desc_lo}}</td>
                      <td>{{col.code_l}}</td>
                      <td>{{col.old_code_l}}</td>
                      <td>{{col.cost_lo}}</td>
                      <td>{{col.lead_time}}</td>
                      <td><q-icon :name="col.fast_execution && 'font_check' || 'font_close'" /></td>
                      <td>{{col.fast_exec_cost}}</td>
                      <td>{{col.fast_exec_time}}</td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
          <div class="mt-16 flex justify-end">
            <q-btn label="Отмена" color="red" class="mr-2" @click.native="fullModal = false"/>
            <q-btn label="Сохранить" color="primary" @click.native="fullModal = false"/>
          </div>
        </div>
      </template>
    </FullModal>
  </div>
</template>

<script>
import Modal from "../components/Modal.vue";
import LoadsSpinner from "../components/Loads-spinner.vue";
import {computed, onMounted, ref} from "vue";
import { useRoute, useRouter } from 'vue-router'
import axios from "axios";
import FullModal from "../components/FullModal.vue";
import {useStore} from "vuex";
import Breadcrumbs from "../components/Breadcrumbs.vue";
export default {
  name: "ResearchOption",
  components: {Breadcrumbs, FullModal, LoadsSpinner, Modal},

  setup () {
    let store = useStore()
    let route = useRoute()
    let ResearchOption = ref([])
    let editResearchOption = ref({})
    let Index = ref({})
    let Category = ref({})
    let LaboratoryResearch = ref({})
    let InvestigatedBiologicalMaterial = ref([])
    let ExpendableMaterials = ref([])
    let CodeAndConditionsForLaboratoryTests = ref([])
    let columns = ref([])
    let pathName = computed(function () {
      return store.state.path
    });
    let isSearch = computed(function () {
      return store.state.isSearch
    });
    const head = [
      {id: 1,name: 'Название лаболатории'},
      {id: 2,name: 'Полное название'},
      {id: 3,name: 'Описание'},
      {id: 4,name: 'Код исследования'},
      {id: 5,name: 'Старый код исследования'},
      {id: 6,name: 'Цена исследования'},
      {id: 7,name: 'Срок исследования'},
      {id: 8,name: 'Быстрое исследование'},
      {id: 9,name: 'Цена быстрого исследования'},
      {id: 10,name: 'Срок быстрого исследования'}
    ]
    let load = ref(false)
    let modalEdit = ref(false)
    let fullModal = ref(false)

    async function init () {
      load.value = true
      if (localStorage.index) {
        Index.value = JSON.parse(localStorage.getItem('index'))
        Category.value = JSON.parse(localStorage.getItem('Category'))
        if (localStorage.LaboratoryResearch) LaboratoryResearch.value = JSON.parse(localStorage.getItem('LaboratoryResearch'))
        else await axios.get('http://188.120.231.191:3000/lab_research?id_clr=eq.'+(route.params.id_lr || Category.value.id_lr || route.params.id)).then(res => {
          res.data.filter(el => {
            if (el.id_lr == (route.params.id_lr || route.params.id)) return LaboratoryResearch.value = el
          })
        })
      }
      await axios.get('http://188.120.231.191:3000/research_options?id_lr=eq.'+(route.params.id_lr || Category.value.id_lr || route.params.id))
        .then(res => {
          ResearchOption.value = res.data
          load.value = false
        })
        .catch(res => {
          ResearchOption.value = [{
            // name_lr: route.params.element.name_lr,
            // id_ro: '',
            // ResearchOption.DescriptionRO: '',
          }]
          load.value = false
        })
      await axios.get(`http://188.120.231.191:3000/lab_research?id_lr=eq.${route.params.id_lr || Category.value.id_lr || route.params.id}&select=id_lr,name_lr,research_options(id_ro,bm_of_study(id_bms,bio_materials(id_bm,name_bm)))`)
        .then(res => {
          InvestigatedBiologicalMaterial.value = res.data
        })
      await axios.get(`http://188.120.231.191:3000/lab_research?id_lr=eq.${route.params.id_lr || Category.value.id_lr || route.params.id}&select=id_lr,research_options(id_ro,use_m(id_m,materials(id_m,name_m)))`)
        .then(res => {
          ExpendableMaterials.value = res.data
        })
      await axios.get(`http://188.120.231.191:3000/lab_research?id_lr=eq.${route.params.id_lr || Category.value.id_lr || route.params.id}&select=id_lr,research_options(id_ro,laboratorys_options(id_lo,code_l,old_code_l,desc_lo,fast_execution,cost_lo,fast_exec_cost,lead_time,fast_exec_time,starting_from_this_date,laboratories(id_labs,name_lab)))`)
        .then(res => {
          CodeAndConditionsForLaboratoryTests.value = res.data
          console.log(res.data)
          res.data.forEach(el => {
            el.research_options.forEach(elem => {
              elem.laboratorys_options.forEach(element => {
                columns.value.push(element)
              })
            })
          })
        })
    }
    function edit (index) {
      editResearchOption.value = ResearchOption.value[index]
      modalEdit.value = true
    }
    function save (el, name, path, params) {
      localStorage.setItem('ResearchOption', JSON.stringify(el))
      store.commit('SET_PATH', {name, index: 3, path, params})
      if (searchArr.value.length) {
        store.commit('SET_STATE_SEARCH')
      }
    }
    function setIsSearch () {
      store.commit('SET_STATE_SEARCH')
    }
    function clearSearch () {
      store.commit('SEARCH_CLEAR')
    }

    let searchArr = computed(function () {
      return store.state.searchArray
    });
    onMounted(()=> {
      init()
    })
    return {
      router: useRouter(),
      route,
      pathName,
      searchArr,
      isSearch,
      ResearchOption,
      editResearchOption,
      modalEdit,
      fullModal,
      load,
      Index,
      Category,
      LaboratoryResearch,
      InvestigatedBiologicalMaterial,
      ExpendableMaterials,
      CodeAndConditionsForLaboratoryTests,
      columns,
      head,
      setIsSearch,
      clearSearch,
      save,
      edit
    }
  }
}
</script>

<style scoped lang="scss">
.edit-modal-switch-wrap {
  color: black;
  display: grid;
  grid-template-columns: 1fr 1fr;
  margin-top: 20px;
}
.modal-add-laboratory {
  .head {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-column-gap: 20px;
  }
  .materials {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-column-gap: 20px;
  }
  input {
    background: none;
    border-bottom: 1px solid gray;
    padding: 0 0 0 10px;
    margin-bottom: 5px;
    width: 100%;
  }
}
</style>
